/*
 * DO NOT EDIT.  THIS FILE IS GENERATED FROM
 * nsIRemoteService.idl
 */

package org.mozilla.interfaces;

/**
 * Start and stop the remote service (xremote/phremote), and register
 * windows with the service for backwards compatibility with old xremote
 * clients.
 *
 * @status FLUID This interface is not frozen and is not intended for embedders
 *               who want a frozen API. If you are an embedder and need this
 *               functionality, contact Benjamin Smedberg about the possibility
 *               of freezing the functionality you need.
 */
public interface nsIRemoteService extends nsISupports {

  String NS_IREMOTESERVICE_IID =
    "{a2240f6a-f1e4-4548-9e1a-6f3bc9b2426c}";

  /**
   * Start the remote service. This should not be done until app startup
   * appears to have been successful.
   *
   * @param appName     (Required) Sets a window property identifying the
   *                    application.
   * @param profileName (May be null) Sets a window property identifying the
   *                    profile name.
   */
  void startup(String appName, String profileName);

  /**
   * Register a XUL window with the xremote service. The window will be
   * configured to accept incoming remote requests. If this method is called
   * before startup(), the registration will happen once startup() is called.
   */
  void registerWindow(nsIDOMWindow aWindow);

  /**
   * Stop the remote service from accepting additional requests.
   */
  void shutdown();

}